package com.example.application.views;


import java.time.LocalDateTime;

import javax.annotation.PostConstruct;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.vaadin.spring.events.EventBus;

import com.vaadin.flow.component.AttachEvent;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.component.html.Pre;
import com.vaadin.flow.spring.annotation.UIScope;

@Controller
@UIScope
@SuppressWarnings("serial")
public class LeftView extends Div {

  private static Logger logger = LoggerFactory.getLogger(LeftView.class);
 
  private @Autowired EventBus.UIEventBus uiEventBus;
  
  public LeftView() {
    setSizeFull();
  }

  @Override
  protected void onAttach(AttachEvent attachEvent) {
    logger.trace("onAttach left: {}", attachEvent);
  }
  
  @PostConstruct
  public void init() {

    add (new Pre("left side"));
    
    Button button = new Button("Click me!", 
        e -> { uiEventBus.publish(this, "clicked @ " + LocalDateTime.now()); });
    add(button);

  }

}