package com.example.application.views;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;

import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.component.page.Push;
import com.vaadin.flow.component.splitlayout.SplitLayout;
import com.vaadin.flow.router.PageTitle;
import com.vaadin.flow.router.PreserveOnRefresh;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.spring.annotation.UIScope;

@Route("")
@PageTitle("EventBus Demo")
@UIScope              // allows several separated UI sessions
@PreserveOnRefresh    // browser refresh button shall not destroy the current session
@Push                 // needed for server-side pushes
@SuppressWarnings("serial")
public class MainView extends VerticalLayout {

  private @Autowired LeftView leftView;

  private @Autowired RightView rightView;
  
  public MainView() {
    setSizeFull();
  }
  
  @PostConstruct
  private void init() {
    
    SplitLayout splitPane = new SplitLayout();
    splitPane.setSizeFull(); 
    
    splitPane.addToPrimary(leftView);  
    splitPane.addToSecondary(rightView);
    
    add(splitPane);
  }

}
