package com.example.application.views;

import javax.annotation.PostConstruct;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.vaadin.spring.events.Event;
import org.vaadin.spring.events.EventBus;
import org.vaadin.spring.events.annotation.EventBusListenerMethod;

import com.vaadin.flow.component.AttachEvent;
import com.vaadin.flow.component.DetachEvent;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.component.html.Label;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.spring.annotation.UIScope;

@SuppressWarnings("serial")
@Controller
@UIScope
public class RightView extends VerticalLayout {

  private static Logger logger = LoggerFactory.getLogger(RightView.class);

  private @Autowired EventBus.UIEventBus uiEventBus;

  public RightView() {
    setSizeFull();
  }

  @Override
  protected void onAttach(AttachEvent attachEvent) {
    logger.trace("onAttach: {}", attachEvent);
    
    // plan B: re-subscribe in onAttach()
    // uiEventBus.subscribe(this);
  }

  @Override
  protected void onDetach(DetachEvent detachEvent) {
    logger.trace("onDetach: {}", detachEvent);
    
    // plan B: unsubscribe in onDetach()
    // uiEventBus.unsubscribe(this);
  }

  @PostConstruct
  public void init() {

    add(new Label("right side"));
    add(new TextField("field 1", "value 1"));
    add(new TextField("field 2", "value 2"));
    
    // plan A: subscribe once
    uiEventBus.subscribe(this);
  }


  @EventBusListenerMethod
  protected void onEvent(Event<String> e) {
    logger.trace("onEvent: {}", e);

    add(new Label(e.getPayload()));
  }

}
